#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Indicator;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Strategy;
#endregion

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    /// <summary>
    /// Enter the description of your strategy here
    /// </summary>
    [Description("Enter the description of your strategy here")]
    public class ZsBorrar01 : Strategy
    {
        #region Variables
        private int periodo0 = 233; // Default setting for Periodo0
        private int periodo1 = 5; // Default setting for Periodo1
        private int periodo2 = 100; // Default setting for Periodo2
		private int periodo3 = 48; // Default setting for Periodo3
        private double filtroVenta = 1; // Default setting for FiltroVenta
        private double filtroCompra = 1; // Default setting for FiltroCompra
        
		private DataSeries dsSource;
		
        #endregion

        /// <summary>
        /// This method is used to configure the strategy and is called once before any strategy method is called.
        /// </summary>
        protected override void Initialize()
        {
            CalculateOnBarClose = true;
			dsSource = new DataSeries(this);
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			dsSource.Set(0, WMA(Close, periodo0)[0] );
			
			if (
					( WMA(dsSource, periodo1)[0] 	< WMA(dsSource, periodo2)[0] )
				&&	( dsSource[0] + filtroVenta 	< WMA(dsSource, periodo3)[0] ) )
				EnterShort(1, "EntrarCorto");
			if (
					( WMA(dsSource, periodo1)[0] 	> WMA(dsSource, periodo2)[0] )
				&&	( dsSource[0] - filtroCompra 	> WMA(dsSource, periodo3)[0] ) )
				EnterLong(1, "EntrarLargo");
        }

        #region Properties
        [Description("")]
        [Category("Parameters")]
        public int Periodo0
        {
            get { return periodo0; }
            set { periodo0 = Math.Max(1, value); }
        }

        [Description("")]
        [Category("Parameters")]
        public int Periodo1
        {
            get { return periodo1; }
            set { periodo1 = Math.Max(1, value); }
        }

        [Description("")]
        [Category("Parameters")]
        public int Periodo2
        {
            get { return periodo2; }
            set { periodo2 = Math.Max(1, value); }
        }

        [Description("")]
        [Category("Parameters")]
        public double FiltroVenta
        {
            get { return filtroVenta; }
            set { filtroVenta = Math.Max(0, value); }
        }

        [Description("")]
        [Category("Parameters")]
        public double FiltroCompra
        {
            get { return filtroCompra; }
            set { filtroCompra = Math.Max(0, value); }
        }

        [Description("")]
        [Category("Parameters")]
        public int Periodo3
        {
            get { return periodo3; }
            set { periodo3 = Math.Max(1, value); }
        }
        #endregion
    }
}
